"use strict";
/*----------------------------------
- DEPENDANCES
----------------------------------*/
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
// Npm
var fs_extra_1 = __importDefault(require("fs-extra"));
var cheerio_1 = __importDefault(require("cheerio"));
var jsonld_extract_1 = __importDefault(require("jsonld-extract"));
// Libs
var utils_1 = require("../utils");
var defaultRequest = function (_a) {
    var url = _a.url, method = _a.method, body = _a.body, headers = _a.headers, proxy = _a.proxy;
    var got;
    try {
        got = require("got");
    }
    catch (error) {
        throw new Error("No request adapter was specified in options.requests, and got was not found in dependancies.");
    }
    return got({
        url: url,
        method: method,
        body: body,
        headers: headers,
        // Prend en compte les probabilités d'échec des proxies
        retry: proxy !== undefined ? 5 : 0,
        responseType: 'text',
        isStream: false,
        resolveBodyOnly: true
        // Déconseillé avec proxy, car temps de réponse assez long
        //timeout: 5000
    });
};
/*----------------------------------
- METHODES
----------------------------------*/
var Scraper = /** @class */ (function () {
    function Scraper(options) {
        var _this = this;
        this.log = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.options.debug && console.log.apply(console, __spreadArray(["[scraper][" + _this.options.id + "]"], __read(args)));
        };
        this.warn = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return console.warn.apply(//this.options.debug &&
            console, __spreadArray(["[scraper][" + _this.options.id + "]"], __read(args)));
        };
        this.options = __assign(__assign({}, Scraper.defaultOptions), options);
    }
    Scraper.prototype.scrape = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var html, url, proxy, requestAdapter, e_1, fichierLocal, $, element, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!('url' in this.options)) return [3 /*break*/, 7];
                        url = this.options.url;
                        if (!(this.options.proxy !== undefined)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.options.proxy.get()];
                    case 1:
                        proxy = _a.sent();
                        url = proxy.prefix + url;
                        _a.label = 2;
                    case 2:
                        this.log("Requete vers " + url);
                        requestAdapter = this.options.request || defaultRequest;
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, requestAdapter(__assign(__assign({}, this.options), { url: url, method: this.options.method || 'GET' }))];
                    case 4:
                        html = _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        e_1 = _a.sent();
                        if (this.options.onError)
                            this.options.onError('request', e_1, this.options, config);
                        else
                            throw e_1;
                        return [3 /*break*/, 6];
                    case 6:
                        if (html && this.options.outputDir) {
                            fichierLocal = this.options.outputDir + '/' + this.options.id + '.html';
                            fs_extra_1["default"].outputFileSync(fichierLocal, html);
                        }
                        return [3 /*break*/, 8];
                    case 7:
                        html = this.options.html;
                        _a.label = 8;
                    case 8:
                        // Extraction code html
                        if (html === undefined)
                            return [2 /*return*/, []];
                        $ = cheerio_1["default"].load(html);
                        element = $('html');
                        return [4 /*yield*/, this.extractItems(config, $, element)];
                    case 9:
                        results = _a.sent();
                        this.log("Termin\u00E9.");
                        return [2 /*return*/, results];
                }
            });
        });
    };
    Scraper.prototype.extractItems = function (config, $, elements) {
        return __awaiter(this, void 0, void 0, function () {
            var finder, itemsList, fichierLocal, items;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(config.items === undefined)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.extractData(config, $, elements, 0)];
                    case 1: return [2 /*return*/, [
                            _a.sent()
                        ]];
                    case 2:
                        finder = function (selector) { return elements.find(selector); };
                        itemsList = config.items(finder).toArray();
                        this.log("[" + this.options.id + "] " + itemsList.length + " Items trouv\u00E9s");
                        if (itemsList.length === 0 && this.options.outputDir) {
                            fichierLocal = this.options.outputDir + '/' + this.options.id + '.html';
                            fs_extra_1["default"].outputFileSync(fichierLocal, $.root().html());
                            // Pas normal
                            this.warn("Aucun r\u00E9sultat trouv\u00E9. html enregistr\u00E9 dans " + fichierLocal);
                        }
                        items = [];
                        return [4 /*yield*/, Promise.all(itemsList.map(function (item, index) {
                                return _this.extractData(config, $, $(item), index).then(function (itemData) {
                                    if (itemData) {
                                        items.push(itemData);
                                        _this.log("[" + _this.options.id + "] Crawled data", itemData);
                                    }
                                });
                            }))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, items];
                }
            });
        });
    };
    // object = données crawlées
    // 0 = exclusion de l'item
    // -1 = Arrêt de l'itération des résultats
    Scraper.prototype.extractData = function (config, $, element, index) {
        return __awaiter(this, void 0, void 0, function () {
            var finder, $jsonld, itemData, _a, _b, _i, dataname, value, error_1, exclude, processResult, error_2;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        finder = function (selector) { return element.find(selector); };
                        $jsonld = jsonld_extract_1["default"]($ /*, this.options.debug*/);
                        itemData = typeof config.extract === 'function'
                            ? config.extract(finder, $jsonld, element)
                            : config.extract;
                        _a = [];
                        for (_b in itemData)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 9];
                        dataname = _a[_i];
                        value = itemData[dataname];
                        if (!(typeof value === 'object' && value._subset === true)) return [3 /*break*/, 6];
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.extractItems(value, $, element)];
                    case 3:
                        value = _c.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        error_1 = _c.sent();
                        this.warn("[extractData] Erreur lors de l'extraction de " + dataname + ":", error_1);
                        value = null;
                        if (this.options.onError)
                            this.options.onError('extraction', error_1, this.options, config);
                        return [3 /*break*/, 5];
                    case 5: return [3 /*break*/, 7];
                    case 6:
                        if (typeof value === 'string') {
                            value = utils_1.parseFromHTML(value);
                        }
                        _c.label = 7;
                    case 7:
                        // Echec de l'extraction
                        if (value === undefined || value === null || value === '') {
                            exclude = config.required !== undefined && config.required.includes(dataname);
                            this.warn("[extractData] Echec de l'extraction de " + dataname, exclude ? "Exclusion de l'item" : '');
                            if (exclude)
                                return [2 /*return*/, false];
                            value = undefined;
                        }
                        // assignation de la valeur extraite
                        itemData[dataname] = value;
                        _c.label = 8;
                    case 8:
                        _i++;
                        return [3 /*break*/, 1];
                    case 9:
                        this.log('[extractData]', this.options.id, 'Données brutes extraites:', itemData);
                        if (!(config.process !== undefined)) return [3 /*break*/, 13];
                        _c.label = 10;
                    case 10:
                        _c.trys.push([10, 12, , 13]);
                        return [4 /*yield*/, config.process(itemData, index)];
                    case 11:
                        processResult = _c.sent();
                        if (processResult === false)
                            return [2 /*return*/, false];
                        this.log('[extractData]', this.options.id, 'Données après traitement:', processResult);
                        return [2 /*return*/, processResult];
                    case 12:
                        error_2 = _c.sent();
                        this.warn('[extractData]', this.options.id, "Erreur lors du traitement des données", error_2);
                        if (this.options.onError)
                            this.options.onError('processing', error_2, this.options, config);
                        return [2 /*return*/, false];
                    case 13: return [2 /*return*/, itemData];
                }
            });
        });
    };
    Scraper.defaultOptions = {};
    return Scraper;
}());
exports["default"] = Scraper;
