import type { Cheerio, Element } from "cheerio";
import type { TJsonldReader } from 'jsonld-extract';
import type Proxies from '../ProxyManager';
export declare type TDonnees = {
    [cle: string]: any;
};
declare type TFinder = (selector: string) => Cheerio<Element>;
export declare type TScraperActions<TExtractedData extends TDonnees, TProcessedData extends TDonnees = {}> = {
    items?: ($: TFinder) => Cheerio<Element>;
    extract: (TDataList<TExtractedData> | (($: TFinder, $jsonld: TJsonldReader, element: Cheerio<Element>) => TDataList<TExtractedData>));
    process?: (data: TExtractedData, index: number) => Promise<TProcessedData | false>;
    required?: string[];
};
declare type TDataList<TExtractedData extends TDonnees> = {
    [name in keyof TExtractedData]: /* Extraction */ TScraperActions<TExtractedData> | /* Raw data */ any;
};
declare type TBaseOptions = {
    id: string;
    debug?: boolean;
    outputDir?: string;
    onError?: (type: 'request' | 'extraction' | 'processing', error: Error, options: TOptions, scraperOptions: TScraperActions<{}>) => void;
};
export declare type TRequestOptions = {
    url: string;
    method?: HttpMethod;
    body?: string;
    headers?: {
        [cle: string]: string;
    };
};
export declare type TOptionsWithRequest = TBaseOptions & TRequestOptions & {
    proxy?: Proxies;
    request?: (options: TOptionsWithRequest) => Promise<string>;
};
export declare type TOptionsWithHtml = TBaseOptions & {
    html: string;
};
export declare type TOptions = TOptionsWithRequest | TOptionsWithHtml;
export declare type HttpMethod = 'GET' | 'POST' | 'PUT' | 'PATCH' | 'HEAD' | 'DELETE' | 'OPTIONS' | 'TRACE' | 'get' | 'post' | 'put' | 'patch' | 'head' | 'delete' | 'options' | 'trace';
export {};
