export { default as validate } from './validate';
import { TGlobalOptions, TRequestWithExtractors, TRequestWithBody, TScrapeResult, TExtractor, ValueExtractor } from './types';
export type { TExtractedPrice } from './types';
declare type TOptions = Omit<TRequestWithExtractors, 'extract' | 'url' | 'method'>;
export default class Scraper {
    apiKey: string;
    private options;
    constructor(apiKey: string, options?: TGlobalOptions);
    scrape<TData extends any = any>(requests: TRequestWithExtractors[]): Promise<TScrapeResult<TData>[]>;
    get<TData extends any = any>(url: string, options?: TOptions, extract?: TExtractor | ValueExtractor): Promise<TScrapeResult<TData>>;
    post<TData extends any = any>(url: string, body: TRequestWithBody["body"], bodyType: TRequestWithBody["bodyType"], options?: TOptions, extract?: TExtractor | ValueExtractor): Promise<TScrapeResult<TData>>;
}
export declare const $: (selector: string) => ValueExtractor;
