"use strict";
/*----------------------------------
- DEPENDANCES
----------------------------------*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.$ = exports.validate = void 0;
// Node.js
var request_1 = __importDefault(require("request"));
// Internal
var validate_1 = __importDefault(require("./validate"));
var validate_2 = require("./validate");
__createBinding(exports, validate_2, "default", "validate");
/*----------------------------------
- TYPE
----------------------------------*/
var types_1 = require("./types");
/*----------------------------------
- VARIOUS DELCARATIONS
----------------------------------*/
var local = process.argv.includes('-local');
var ApiError = /** @class */ (function (_super) {
    __extends(ApiError, _super);
    function ApiError(code, message) {
        var _this = _super.call(this, message) || this;
        _this.code = code;
        return _this;
    }
    return ApiError;
}(Error));
var defaultAdapter = function (options) { return new Promise(function (resolve, reject) { return (0, request_1["default"])(__assign(__assign({}, options), { json: true }), function (error, response) {
    if (response && response.statusCode !== 200)
        error = new ApiError(response.statusCode, response.body);
    if (error) {
        reject(error);
        return;
    }
    resolve(response.body);
}); }); };
/*----------------------------------
- SCRAPER
----------------------------------*/
var Scraper = /** @class */ (function () {
    function Scraper(apiKey, options) {
        if (options === void 0) { options = {}; }
        this.apiKey = apiKey;
        this.options = options;
    }
    Scraper.prototype.scrape = function (requests) {
        var sendRequest = this.options.adapter || defaultAdapter;
        return sendRequest({
            method: 'POST',
            url: local ? 'http://localhost:3011/v0' : 'https://scrapingapi.io/v0',
            headers: {
                'content-type': 'application/json',
                'accepted': 'application/json',
                'Authorization': this.apiKey
            },
            body: {
                requests: (0, validate_1["default"])(requests)
            }
        });
    };
    Scraper.prototype.get = function (url, options, extract) {
        return this.scrape([__assign({ method: 'GET', url: url, extract: extract }, options)]).then(function (res) { return res[0]; });
    };
    Scraper.prototype.post = function (url, body, bodyType, options, extract) {
        return this.scrape([__assign({ method: 'POST', url: url, extract: extract, body: body, bodyType: bodyType }, options)]).then(function (res) { return res[0]; });
    };
    return Scraper;
}());
exports["default"] = Scraper;
var $ = function (selector) { return new types_1.ValueExtractor(selector); };
exports.$ = $;
/*module.exports = (apiKey: string) => ({
    page: new Scraper(apiKey),
    $: $
})*/ 
