"use strict";
/*----------------------------------
- CONST
----------------------------------*/
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
exports.ValueExtractor = exports.devices = exports.dataFilters = exports.bodyTypes = exports.allowedMethods = void 0;
exports.allowedMethods = ["GET", "POST"];
exports.bodyTypes = ["form", "json"];
exports.dataFilters = ["url", 'price'];
exports.devices = ['desktop', 'tablet', 'mobile'];
var ValueExtractor = /** @class */ (function () {
    function ValueExtractor(select) {
        this.options = {
            select: select
        };
    }
    ValueExtractor.prototype.attr = function (attribute) {
        this.options.attr = attribute;
        return this;
    };
    ValueExtractor.prototype.each = function (values) {
        return { $foreach: this.options.select, items: values };
    };
    ValueExtractor.prototype.filter = function () {
        var e_1, _a;
        var filterNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            filterNames[_i] = arguments[_i];
        }
        if (this.options.filters === undefined)
            this.options.filters = filterNames;
        else
            try {
                for (var filterNames_1 = __values(filterNames), filterNames_1_1 = filterNames_1.next(); !filterNames_1_1.done; filterNames_1_1 = filterNames_1.next()) {
                    var filterName = filterNames_1_1.value;
                    if (this.options.filters.includes(filterName))
                        throw new Error("The ".concat(this.filter, " filter has already be set for this selector."));
                    else
                        this.options.filters.push(filterName);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (filterNames_1_1 && !filterNames_1_1.done && (_a = filterNames_1["return"])) _a.call(filterNames_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        return this;
    };
    ValueExtractor.prototype.optional = function (isOptional) {
        if (isOptional === void 0) { isOptional = true; }
        this.options.required = !isOptional;
        return this;
    };
    ValueExtractor.prototype.html = function () {
        this.options.attr = 'html';
        return this;
    };
    ValueExtractor.prototype.text = function () {
        this.options.attr = 'html';
        return this;
    };
    return ValueExtractor;
}());
exports.ValueExtractor = ValueExtractor;
